/*  @(#)85  1.1 src/com/tivoli/pd/jazn/LocalRemoteDemo/PDLRExerciseDialog.java, pd.jazn, am610, 080214a 07/03/15 13:15:34 @(#)  */

/*
 *
 *
 * Licensed Materials - Property of IBM
 * 5748-XX8
 * (c) Copyright International Business Machines Corp. 2006
 * All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *
 * File Name: LRExerciseDialog.java
 */

import javax.swing.JDialog;

import javax.swing.JPanel;
import javax.swing.JLabel;
import javax.swing.JTextField;


import javax.swing.JCheckBox;


import javax.swing.JButton;
/**
 * This class handles the Exercise dialog for the PDLRADemo program.
 * The dialog allows the user to define:
 * <ol>
 * <li>Number of iterations.
 * <li>Disable credential cache
 * <li>Enable timings
 * <li>Uses new PDPrincipals in each iteration
 * <li>User new PDAuthorizationContext in each iteration
 * </ol>
 * <p>
 * Note: When selecting a new PDAuthorizationContext for each
 * iteration, the new PDPrincipal is automatically selected. New
 * Permissions will also be created on each iteration too when the
 * PDAuthoriztionContext is selected.
 * <p>
 * <img src="./images/PDLRADemo3.gif">
 */
public class PDLRExerciseDialog extends JDialog {

	private JPanel jPanel = null;
	private JLabel jLabel = null;
	private JTextField jTF_num_access_decisions = null;
	private JCheckBox jCB_diable_cred_cache = null;
	private JCheckBox jCB_measure_avg_times = null;
	private JButton jButton = null;
	private JButton jButton1 = null;
	private JCheckBox jCB_new_authz_Context = null;
	private JCheckBox jCB_new_PDPrincipal = null;
	private PDLRTestDemo PDLRZDemo = null;
	private PDLRAuthzDemo2 PDLRAuthzD2= null;
	private boolean TearDown = false;
	/**
	 * This method Displays the PDLRADemo Exercise dialog.
	 *
	 * @param lrtd - This is the instantiated PDLRTestDemo object
	 * @param lra_2 - This is the instantiated PDLRAuthzDemo2 object,
	 * the panel where the configuration settings were enter.
	 */
	public PDLRExerciseDialog( PDLRTestDemo lrtd, PDLRAuthzDemo2 lra_2) {
		super();
		PDLRZDemo = lrtd;
		PDLRAuthzD2 = lra_2;
		initialize();
		TearDown = false;
	}
	/**
	 * This method initializes this
	 *
	 * @return void
	 */
	private void initialize() {
        this.setContentPane(getJPanel());
        this.setTitle("PDLRAuthzDemo - Exercise");
        this.setSize(650, 250);
        this.addWindowListener(new java.awt.event.WindowAdapter() {
        	public void windowClosing(java.awt.event.WindowEvent e) {
        		// see if demo has already been torn down
        		if(!TearDown)
        		{
        			PDLRZDemo.tearDown(PDLRAuthzD2);	
        		}
        	}
        });
			
	}
	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanel() {
		if (jPanel == null) {
			jLabel = new JLabel();
			jPanel = new JPanel();
			jPanel.setLayout(null);
			jLabel.setBounds(35, 20, 325, 22);
			jLabel.setText("Number of times to execute Access Decision:");
			jPanel.add(jLabel, null);
			jPanel.add(getJTF_num_access_decisions(), null);
			jPanel.add(getJCB_diable_cred_cache(), null);
			jPanel.add(getJCB_measure_avg_times(), null);
			jPanel.add(getJCB_new_authz_Context(), null);
			jPanel.add(getJCB_new_PDPrincipal(), null);
			jPanel.add(getJButton(), null);
			jPanel.add(getJButton1(), null);
		}
		return jPanel;
	}
	/**
	 * This method initializes jTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTF_num_access_decisions() {
		if (jTF_num_access_decisions == null) {
			jTF_num_access_decisions = new JTextField();
			jTF_num_access_decisions.setBounds(35, 45, 40, 19);
			jTF_num_access_decisions.setText("1");
		}
		return jTF_num_access_decisions;
	}
	/**
	 * This method initializes jCheckBox	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */
	private JCheckBox getJCB_diable_cred_cache() {
		if (jCB_diable_cred_cache == null) {
			jCB_diable_cred_cache = new JCheckBox();
			jCB_diable_cred_cache.setBounds(34, 72, 225, 21);
			jCB_diable_cred_cache.setText("Disable Credential Cache");
		}
		return jCB_diable_cred_cache;
	}
	/**
	 * This method initializes jCheckBox1	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */
	private JCheckBox getJCB_measure_avg_times() {
		if (jCB_measure_avg_times == null) {
			jCB_measure_avg_times = new JCheckBox();
			jCB_measure_avg_times.setBounds(34, 105, 225, 21);
			jCB_measure_avg_times.setText("Measure and Average Times");
		}
		return jCB_measure_avg_times;
	}
	/**
	 * This method initializes jButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButton() {
		if (jButton == null) {
			jButton = new JButton();
			jButton.setBounds(218, 191, 155, 31);
			jButton.setText("Cancel (Tear Down)");
			jButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					PDLRZDemo.tearDown(PDLRAuthzD2);
					// let the closing routine know we've already done this
					TearDown = true;
					dispose();
				}
			});
		}
		return jButton;
	}
	/**
	 * This method initializes jButton1	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButton1() {
		if (jButton1 == null) {
			jButton1 = new JButton();
			jButton1.setBounds(47, 191, 139, 31);
			jButton1.setText("Run Test");
			jButton1.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					/*System.out.println("actionPerformed()"); // TODO Auto-generated Event stub actionPerformed()
					System.out.println("numb of runs"+getJTF_num_access_decisions().getText());
					System.out.println("disble cache "+getJCB_diable_cred_cache().isSelected());
					System.out.println("Measure Avg Times "+getJCB_measure_avg_times().isSelected());
					System.out.println("new authz context "+getJCB_new_authz_Context().isSelected());
					System.out.println("new PDPrinc "+getJCB_new_PDPrincipal().isSelected());*/
					String lclPropString = PDLRAuthzD2.getJTF_working_dir_text()
					                       +"/"
					                       +PDLRAuthzD2.getJTF_local_appName_text()+".properties";
					String remPropString = PDLRAuthzD2.getJTF_working_dir_text()
                                           +"/"
                                           +PDLRAuthzD2.getJTF_remote_appName_text()+".properties";
					PDLRZDemo.runDemo(Integer.parseInt(getJTF_num_access_decisions().getText()),
							getJCB_diable_cred_cache().isSelected(),
					        getJCB_measure_avg_times().isSelected(),
					        getJCB_new_PDPrincipal().isSelected(),
					        getJCB_new_authz_Context().isSelected(),
							lclPropString,
							remPropString);
							
							
					
				}
			});
		}
		return jButton1;
	}
	/**
	 * This method initializes jCheckBox	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */
	private JCheckBox getJCB_new_authz_Context() {
		if (jCB_new_authz_Context == null) {
			jCB_new_authz_Context = new JCheckBox();
			jCB_new_authz_Context.setBounds(34, 129, 400, 21);
			jCB_new_authz_Context.setText("Use new PDAuthorizationContext for each decision");
			jCB_new_authz_Context.addChangeListener(new javax.swing.event.ChangeListener() {
				public void stateChanged(javax.swing.event.ChangeEvent e) {
					if(jCB_new_authz_Context.isSelected())
					{
						jCB_new_PDPrincipal.setSelected(true);
						jCB_new_PDPrincipal.setEnabled(false);
					}
					else
					{
						jCB_new_PDPrincipal.setEnabled(true);
					}
				}
			});
		}
		return jCB_new_authz_Context;
	}
	/**
	 * This method initializes jCheckBox	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */
	private JCheckBox getJCB_new_PDPrincipal() {
		if (jCB_new_PDPrincipal == null) {
			jCB_new_PDPrincipal = new JCheckBox();
			jCB_new_PDPrincipal.setBounds(34, 161, 350, 21);
			jCB_new_PDPrincipal.setText("Use new PDPrincipal for each access decision");
		}
		return jCB_new_PDPrincipal;
	}
      }  //  @jve:decl-index=0:visual-constraint="75,-6"
